#!/usr/bin/env python2
import file as jsf
import os
import subprocess
import sys
import glob

class DontDoIt(Exception): pass

def create_model(dirname0,modelname):
    modeldir="../models/"+modelname+'/'
    if os.path.isdir(modeldir):
        raise DontDoIt("Model directory "+modeldir+" already present")

    if "/" not in dirname0[-1]:
        dirname = dirname0+"/"
    else:
        dirname = dirname0

    if not os.path.isdir(dirname):
        raise DontDoIt("Directory "+dirname+" is not present")

    print "doing directory",dirname
    with open(dirname+"model_data/listmassive") as f:
        linesmassive = f.read().strip()
    with open(dirname+"model_data/listmassless") as f:
        linesmassless = f.read().strip()
    os.makedirs(modeldir)
    os.makedirs(modeldir+"QGRAF")
    os.makedirs(modeldir+"QGRAF/proc_0loop")
    os.makedirs(modeldir+"FORM")
    os.makedirs(modeldir+"FORM/proc_0loop")
    subprocess.call("cp -r "+dirname+"model* "+modeldir+"QGRAF/",shell=True)
    subprocess.call("cp limpia.sh "+modeldir+"FORM/proc_0loop/",shell=True)
    subprocess.call("cp colour.faux "+modeldir+"FORM/proc_0loop/",shell=True)
    myrepl= ('MASSLESSPARTICLES',linesmassless),('MASSIVEPARTICLES',linesmassive)
    jsf.dress_skeleton(myrepl,'qgraf.skeleton.0loop.dat',modeldir+"QGRAF/qgraf.skeleton.0loop.dat")
 

    if len(linesmassive)>0:        
        os.makedirs(modeldir+"QGRAF/proc_1loop")
        os.makedirs(modeldir+"FORM/proc_1loop")
        jsf.dress_skeleton(myrepl,'qgraf.skeleton.1loop.dat',modeldir+"QGRAF/qgraf.skeleton.1loop.dat")
        subprocess.call("cp limpia.sh "+modeldir+"FORM/proc_1loop/",shell=True)
        subprocess.call("cp colour.faux "+modeldir+"FORM/proc_1loop/",shell=True)

if __name__=='__main__':
    try:
        create_model(sys.argv[1],sys.argv[2])
    except DontDoIt as e:
        print(e.args[0])
