#!/usr/bin/env python2

import sys
import os
import subprocess

import run_all
import run_qgraf
import generate_form
import run_form

subprocess.call("cp -R ../source/L2SM ../models/",shell=True)
inputfiledir='../input/'
modeldir='../models/'
inputfilelist=['listofparticles_L4.dat','listofparticles_0F.dat','listofparticles_2F_0S_3D.dat','listofparticles_2F_1S_2D.dat','listofparticles_2F_2S_1D.dat','listofparticles_2F_3S_0D.dat']
effmodeldir=['L4SM/','L6SM_0F/','L6SM_2F_0S_3D/','L6SM_2F_1S_2D/','L6SM_2F_2S_1D/','L6SM_2F_3S_0D/']

if len(sys.argv)==2:
    NPmodeldir=sys.argv[1]
    if os.path.isdir(NPmodeldir):
        for ipart,partfile in enumerate(inputfilelist):
            run_all.run_all(inputfiledir+partfile,modeldir+effmodeldir[ipart])
            run_all.run_all(inputfiledir+partfile,NPmodeldir)
    else:
        print "Model directory "+modeldir+" does not exist"
else:
    print "usage: python match_model.py NPmodeldirectory"
