#!/usr/bin/env python2

import subprocess
import glob
import sys
import os

def better_log(file):
    print file
    if not os.path.isfile(file+".mat"):
        with open(file) as f:
            lines = f.read().splitlines()
            for i,li in enumerate(lines):
                if "ampl" in li:
                    i0=i;
                if ";" in li:
                    i1=i;
        lin=''.join([x.strip() for x in  lines[i0:i1+1]])

        for i in range(200):
            for j in range(200):
                lin=lin.replace("d_(i"+str(i+1)+",i"+str(j+1)+")","dd[i"+str(i+1)+",i"+str(j+1)+"]")
                lin=lin.replace("d_(y"+str(i+1)+",y"+str(j+1)+")","dd[y"+str(i+1)+",y"+str(j+1)+"]")
                lin=lin.replace("d_(mu"+str(i+1)+",mu"+str(j+1)+")","dd[mu"+str(i+1)+",mu"+str(j+1)+"]")
                lin=lin.replace("d_(a"+str(i+1)+",a"+str(j+1)+")","dd[a"+str(i+1)+",a"+str(j+1)+"]")
                lin=lin.replace("e_","ee")
        print lin
        with open(file+".mat","w") as ff:
            ff.write(lin)



def run_form(dirname0):
    if os.path.isdir(dirname0):
        filesdonealready=[]
        if "/" not in dirname0[-1]:
            dirname = dirname0+"/"
        else:
            dirname = dirname0
        print "Running form on directory",dirname
        currentdir=os.getcwd()

        if os.path.isdir(dirname+"FORM/proc_0loop/"):
            os.chdir(dirname+"FORM/proc_0loop/")
            filelist=glob.glob("*frm")
            for fil in filelist:
                if os.path.isfile(fil[:-4]+".log"):
                    print "file",fil[:-4]+".log","present, next please!"
                    filesdonealready.append(fil[:-4]+".log")
                else:
                    print "form -l "+fil
                    subprocess.call("form -l "+fil,shell= True)
                better_log(fil[:-4]+".log")
            os.chdir(currentdir)
        if os.path.isdir(dirname+"FORM/proc_1loop/"):
            os.chdir(dirname+"FORM/proc_1loop/")
            filelist=glob.glob("*frm")
            for fil in filelist:
                if os.path.isfile(fil[:-4]+".log"):
                    print "file",fil[:-4]+".log","present, next please!"
                    filesdonealready.append(fil[:-4]+".log")
                else:
                    print "form -l "+fil
                    subprocess.call("form -l "+fil,shell= True)
                better_log(fil[:-4]+".log")
            os.chdir(currentdir)

        if len(filesdonealready)>0:
            print "The following files were done already"
            print "If you want to do them, remove them and run again"
            for x in filesdonealready:
                print x
    else:
        print "not a valid directory"

if __name__=='__main__':

    run_form(sys.argv[1])

