#!/usr/bin/env python2
import file as jsf
import os
import subprocess
import sys
import glob




def run_qgraf(listofparticles,dirname0):
    if os.path.isdir(dirname0):
        if os.path.isfile(listofparticles):
            if "/" not in dirname0[-1]:
                dirname = dirname0+"/"
            else:
                dirname = dirname0
            print "doing directory",dirname
            with open(listofparticles) as f:
                lines = f.read().strip().splitlines()
            for li in lines:
                outfile=" ".join(li.split()).replace(" ","_").replace("[","").replace("]","")
                #partlist=li.replace(" ",",")
                partlist=','.join(li.split())
                filelist=glob.glob(dirname+"QGRAF/qgraf.skeleton*.dat")
                for fil in filelist:
                    outputfilename=dirname+"QGRAF/proc_"+fil.split('/')[-1].split('.')[-2]+"/"+outfile+".qgf"
                    if os.path.isfile(outputfilename):
                        print "file "+outputfilename+" already present, doing next"
                    else:
                        themodel=dirname+"QGRAF/model"
                        subprocess.call("cp "+themodel+" ./model",shell=True)
                        myrepl=("LISTOFPARTICLES",partlist),("THEMODEL",'model')
                        jsf.dress_skeleton(myrepl,fil,'qgraf.dat')
                        if os.path.isfile('OUTPUTFILE'):
                            subprocess.call("rm OUTPUTFILE",shell=True)
                        subprocess.call("./qgraf", shell=True)
                        subprocess.call("mv OUTPUTFILE "+outputfilename,shell=True)
                        subprocess.call("rm model", shell=True)
                        subprocess.call("rm qgraf.dat", shell=True)
        else:
            print "not a valid list of particles"
    else:
        print "not a valid directory"


if __name__=='__main__':
    run_qgraf(sys.argv[1],sys.argv[2])
