#!/usr/bin/env python2

import sys
import os
import subprocess

import run_qgraf
import generate_form
import run_form




def run_all(inputfile,modeldir0):

    if "/" not in modeldir0[-1]:
    	modeldir = modeldir0+"/"
    else:
        modeldir = modeldir0
    if os.path.isfile(inputfile):
        if os.path.isdir(modeldir):
            # Run QGRAF
            run_qgraf.run_qgraf(inputfile,modeldir)
            # Generate Form
            generate_form.generate_form(modeldir)
            # Run Form
            run_form.run_form(modeldir)
	    # If it is an effective model (only proc_0loop) copy the two point results
            if not os.path.isdir(modeldir+"FORM/proc_1loop"):
                subprocess.call("cp ../source/*log.mat "+modeldir+"FORM/proc_0loop/",shell=True)
        else:
            print "Model directory "+modeldir+" does not exist"
    else:
        print "Input file "+inputfile+" does not exist"


if __name__=='__main__':

    if len(sys.argv)==3:
        print sys.argv  
        inputfile=sys.argv[1]
        modeldir=sys.argv[2]
        run_all(inputfile,modeldir)
    else:
        print "usage: python run_all.py inputfile modeldirectory"
